searchNodes=[{"doc":"Generic functions for working with changesets that are not packaged with Ecto.","ref":"Solicit.Changeset.html","title":"Solicit.Changeset","type":"module"},{"doc":"A module encapsulating the translation layer between a changeset error and the JSON error shape returned in an API response.","ref":"Solicit.Changeset.html#code_and_description/1","title":"Solicit.Changeset.code_and_description/1","type":"function"},{"doc":"Creates a wrapper around Plug.Parsers to catch Parsers Errors. See Plug.Parsers documentation","ref":"Solicit.Plugs.Parsers.html","title":"Solicit.Plugs.Parsers","type":"module"},{"doc":"","ref":"Solicit.Plugs.Parsers.html#call/2","title":"Solicit.Plugs.Parsers.call/2","type":"function"},{"doc":"","ref":"Solicit.Plugs.Parsers.html#init/1","title":"Solicit.Plugs.Parsers.init/1","type":"function"},{"doc":"Casts the given path param to the given type. If the cast fails, returns a 404. Uses Solicit for 404 responses, so only API routes are supported.","ref":"Solicit.Plugs.ValidatePathParam.html","title":"Solicit.Plugs.ValidatePathParam","type":"module"},{"doc":"","ref":"Solicit.Plugs.ValidatePathParam.html#call/2","title":"Solicit.Plugs.ValidatePathParam.call/2","type":"function"},{"doc":"","ref":"Solicit.Plugs.ValidatePathParam.html#init/1","title":"Solicit.Plugs.ValidatePathParam.init/1","type":"function"},{"doc":"Plug options. :param - the string name of the parameter to be cast. Required. :type - the type to cast to using Ecto.Type.cast/2 . Required. :required - if true, requires the parameter to not be nil or an empty string after casting . * * Default :* * ` true ` .","ref":"Solicit.Plugs.ValidatePathParam.html#t:options/0","title":"Solicit.Plugs.ValidatePathParam.options/0","type":"type"},{"doc":"Check to make sure for an endpoint that allows for pagination that both the offset and page query parameter cannot be provided in the same call. It can only be 1 or the other. Also that the provided offset , page , and limit are valid values","ref":"Solicit.Plugs.Validation.PaginationParams.html","title":"Solicit.Plugs.Validation.PaginationParams","type":"module"},{"doc":"","ref":"Solicit.Plugs.Validation.PaginationParams.html#call/2","title":"Solicit.Plugs.Validation.PaginationParams.call/2","type":"function"},{"doc":"","ref":"Solicit.Plugs.Validation.PaginationParams.html#init/1","title":"Solicit.Plugs.Validation.PaginationParams.init/1","type":"function"},{"doc":"Check to make sure that if a query parameter is provided that it has a value /api?test=1&amp;foo=abc123 /api?test=&amp;foo= would be strip out the empty query params and be equiv to /api /api?test=&amp;foo=123 would be strip out the empty query params and be equiv to /api?foo=123","ref":"Solicit.Plugs.Validation.QueryParams.html","title":"Solicit.Plugs.Validation.QueryParams","type":"module"},{"doc":"","ref":"Solicit.Plugs.Validation.QueryParams.html#call/2","title":"Solicit.Plugs.Validation.QueryParams.call/2","type":"function"},{"doc":"","ref":"Solicit.Plugs.Validation.QueryParams.html#init/1","title":"Solicit.Plugs.Validation.QueryParams.init/1","type":"function"},{"doc":"Standardized responses","ref":"Solicit.Response.html","title":"Solicit.Response","type":"module"},{"doc":"Returns a successful accepted response. Normally used to signify that the request was accepted, but might not have finished processing.","ref":"Solicit.Response.html#accepted/1","title":"Solicit.Response.accepted/1","type":"function"},{"doc":"","ref":"Solicit.Response.html#accepted/2","title":"Solicit.Response.accepted/2","type":"function"},{"doc":"","ref":"Solicit.Response.html#accepted/3","title":"Solicit.Response.accepted/3","type":"function"},{"doc":"Returns structs or maps with specific fields extracted. Example def show ( %{ assigns : %{ user : user } } = conn , _params ) do conn |&gt; as_json ( user , [ :id , :first_name , :last_name , :email ] ) end Example w/ Association def show ( %{ assigns : %{ unit : unit } } = conn , _params ) do conn |&gt; as_json ( unit , [ :id , :marketing_name , :street_address_1 , :street_address_2 , :city , :state , full_address : fn unit -&gt; &quot; \#{ unit . street_address_1 } , \#{ unit . city } , \#{ unit . state } &quot; end group : [ :id , :marketing_name ] , residents : [ :id , :first_name , :last_name ] ] ) end If you don't add an associations fields and just the key :group , it will throw an ArgumentError letting you know that you forgot to add the related fields. Note: Associations must be added last in the list or you will result in a syntax error Incorrect: def show ( %{ assigns : %{ unit : unit } } = conn , _params ) do conn |&gt; as_json ( unit , [ :id , :marketing_name , :street_address_1 , :street_address_2 , group : [ :id , :marketing_name ] , :city , :state ] ) end Correct: def show ( %{ assigns : %{ unit : unit } } = conn , _params ) do conn |&gt; as_json ( unit , [ :id , :marketing_name , :street_address_1 , :street_address_2 , :city , :state , group : [ :id , :marketing_name ] , ] ) end","ref":"Solicit.Response.html#as_json/2","title":"Solicit.Response.as_json/2","type":"function"},{"doc":"","ref":"Solicit.Response.html#bad_gateway/1","title":"Solicit.Response.bad_gateway/1","type":"function"},{"doc":"Signifies a bad gateway request.","ref":"Solicit.Response.html#bad_gateway/2","title":"Solicit.Response.bad_gateway/2","type":"function"},{"doc":"Signifies a bad request.","ref":"Solicit.Response.html#bad_request/1","title":"Solicit.Response.bad_request/1","type":"function"},{"doc":"","ref":"Solicit.Response.html#bad_request/2","title":"Solicit.Response.bad_request/2","type":"function"},{"doc":"Signifies a conflicting response.","ref":"Solicit.Response.html#conflict/1","title":"Solicit.Response.conflict/1","type":"function"},{"doc":"","ref":"Solicit.Response.html#conflict/2","title":"Solicit.Response.conflict/2","type":"function"},{"doc":"Returns a successful created response.","ref":"Solicit.Response.html#created/3","title":"Solicit.Response.created/3","type":"function"},{"doc":"","ref":"Solicit.Response.html#forbidden/1","title":"Solicit.Response.forbidden/1","type":"function"},{"doc":"Signifies a forbidden response.","ref":"Solicit.Response.html#forbidden/2","title":"Solicit.Response.forbidden/2","type":"function"},{"doc":"Signifies a gone response.","ref":"Solicit.Response.html#gone/1","title":"Solicit.Response.gone/1","type":"function"},{"doc":"","ref":"Solicit.Response.html#gone/2","title":"Solicit.Response.gone/2","type":"function"},{"doc":"","ref":"Solicit.Response.html#internal_server_error/1","title":"Solicit.Response.internal_server_error/1","type":"function"},{"doc":"Signifies an internal_server_error request.","ref":"Solicit.Response.html#internal_server_error/2","title":"Solicit.Response.internal_server_error/2","type":"function"},{"doc":"","ref":"Solicit.Response.html#method_not_allowed/1","title":"Solicit.Response.method_not_allowed/1","type":"function"},{"doc":"Signifies a method not allowed response.","ref":"Solicit.Response.html#method_not_allowed/2","title":"Solicit.Response.method_not_allowed/2","type":"function"},{"doc":"Returns a successful no_content response. Normally used when deleting.","ref":"Solicit.Response.html#no_content/1","title":"Solicit.Response.no_content/1","type":"function"},{"doc":"","ref":"Solicit.Response.html#not_found/1","title":"Solicit.Response.not_found/1","type":"function"},{"doc":"Signifies a not found response.","ref":"Solicit.Response.html#not_found/2","title":"Solicit.Response.not_found/2","type":"function"},{"doc":"Returns a successful response with no payload.","ref":"Solicit.Response.html#ok/1","title":"Solicit.Response.ok/1","type":"function"},{"doc":"Returns a successful response.","ref":"Solicit.Response.html#ok/3","title":"Solicit.Response.ok/3","type":"function"},{"doc":"Signifies a request_entity_too_large response.","ref":"Solicit.Response.html#request_entity_too_large/1","title":"Solicit.Response.request_entity_too_large/1","type":"function"},{"doc":"","ref":"Solicit.Response.html#request_entity_too_large/2","title":"Solicit.Response.request_entity_too_large/2","type":"function"},{"doc":"","ref":"Solicit.Response.html#service_unavailable/1","title":"Solicit.Response.service_unavailable/1","type":"function"},{"doc":"Signifies a service unavailable request.","ref":"Solicit.Response.html#service_unavailable/2","title":"Solicit.Response.service_unavailable/2","type":"function"},{"doc":"","ref":"Solicit.Response.html#timeout/1","title":"Solicit.Response.timeout/1","type":"function"},{"doc":"Signifies a request timeout response.","ref":"Solicit.Response.html#timeout/2","title":"Solicit.Response.timeout/2","type":"function"},{"doc":"Signifies an too_many_requests request.","ref":"Solicit.Response.html#too_many_requests/1","title":"Solicit.Response.too_many_requests/1","type":"function"},{"doc":"","ref":"Solicit.Response.html#too_many_requests/2","title":"Solicit.Response.too_many_requests/2","type":"function"},{"doc":"","ref":"Solicit.Response.html#unauthorized/1","title":"Solicit.Response.unauthorized/1","type":"function"},{"doc":"Signifies an unauthorized request.","ref":"Solicit.Response.html#unauthorized/2","title":"Solicit.Response.unauthorized/2","type":"function"},{"doc":"","ref":"Solicit.Response.html#unprocessable_entity/1","title":"Solicit.Response.unprocessable_entity/1","type":"function"},{"doc":"Signifies an unprocessable_entity response.","ref":"Solicit.Response.html#unprocessable_entity/2","title":"Solicit.Response.unprocessable_entity/2","type":"function"},{"doc":"Signifies a unsupported_media_type response.","ref":"Solicit.Response.html#unsupported_media_type/1","title":"Solicit.Response.unsupported_media_type/1","type":"function"},{"doc":"","ref":"Solicit.Response.html#unsupported_media_type/2","title":"Solicit.Response.unsupported_media_type/2","type":"function"},{"doc":"An error in the JSON body of an HTTP response.","ref":"Solicit.ResponseError.html","title":"Solicit.ResponseError","type":"module"},{"doc":"","ref":"Solicit.ResponseError.html#bad_gateway/1","title":"Solicit.ResponseError.bad_gateway/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#bad_request/1","title":"Solicit.ResponseError.bad_request/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#conflict/1","title":"Solicit.ResponseError.conflict/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#forbidden/1","title":"Solicit.ResponseError.forbidden/1","type":"function"},{"doc":"Given an Ecto Changeset with errors, convert the errors into a list of ResponseError objects.","ref":"Solicit.ResponseError.html#from_changeset/2","title":"Solicit.ResponseError.from_changeset/2","type":"function"},{"doc":"Given a keyword list entry, attempt to turn it into an ResponseError. Assumption: All Changeset errors are going to relate to a specific database field.","ref":"Solicit.ResponseError.html#from_changeset_error/1","title":"Solicit.ResponseError.from_changeset_error/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#generic_error/1","title":"Solicit.ResponseError.generic_error/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#gone/1","title":"Solicit.ResponseError.gone/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#internal_server_error/1","title":"Solicit.ResponseError.internal_server_error/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#method_not_allowed/1","title":"Solicit.ResponseError.method_not_allowed/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#not_found/1","title":"Solicit.ResponseError.not_found/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#request_entity_too_large/1","title":"Solicit.ResponseError.request_entity_too_large/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#service_unavailable/1","title":"Solicit.ResponseError.service_unavailable/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#timeout/1","title":"Solicit.ResponseError.timeout/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#too_many_requests/1","title":"Solicit.ResponseError.too_many_requests/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#unauthorized/1","title":"Solicit.ResponseError.unauthorized/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#unprocessable_entity/1","title":"Solicit.ResponseError.unprocessable_entity/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#unsupported_media_type/1","title":"Solicit.ResponseError.unsupported_media_type/1","type":"function"},{"doc":"","ref":"Solicit.ResponseError.html#t:t/0","title":"Solicit.ResponseError.t/0","type":"type"},{"doc":"Utilities for working with UUIDs.","ref":"Solicit.UUID.html","title":"Solicit.UUID","type":"module"},{"doc":"Encodes a UUID in short hexadecimal format without any dashes. Generates a random UUID if none is provided. Examples iex&gt; Solicit.UUID.hex(&quot;7f3c1729-b7be-4eed-86a0-e843ac2219e8&quot;) &quot;7f3c1729b7be4eed86a0e843ac2219e8&quot; iex&gt; Solicit.UUID.hex(&lt;&lt;127, 60, 23, 41, 183, 190, 78, 237, 134, 160, 232, 67, 172, 34, 25, 232&gt;&gt;) &quot;7f3c1729b7be4eed86a0e843ac2219e8&quot;","ref":"Solicit.UUID.html#hex/1","title":"Solicit.UUID.hex/1","type":"function"},{"doc":"Returns true if the given value is a UUID with the standard encoding. Examples iex&gt; Solicit.UUID.valid?(&quot;00000000-0000-0000-0000-000000000000&quot;) true iex&gt; Solicit.UUID.valid?(&quot;21985486-b01a-11ea-b3de-0242ac130004&quot;) true iex&gt; Solicit.UUID.valid?(&quot;🍉&quot;) false iex&gt; Solicit.UUID.valid?(&quot;John Jacob Jingle-Heimerschmidt&quot;) false iex&gt; Solicit.UUID.valid?(&quot;&quot;) false iex&gt; Solicit.UUID.valid?(&quot; &quot;) false iex&gt; Solicit.UUID.valid?(&quot; &quot;) false","ref":"Solicit.UUID.html#valid?/1","title":"Solicit.UUID.valid?/1","type":"function"},{"doc":"All notable changes to this project will be documented in this file. See Conventional Commits for commit guidelines.","ref":"changelog.html","title":"Change Log","type":"extras"},{"doc":"Bug Fixes: Add atom() to Response.unprocessible_entity/2 typespec ( #129 )","ref":"changelog.html#1-3-1-2023-05-12","title":"Change Log - 1.3.1 (2023-05-12)","type":"extras"},{"doc":"Features: Add support for atoms to Response.unprocessable_entity/2 ( #112 )","ref":"changelog.html#1-3-0-2023-01-09","title":"Change Log - 1.3.0 (2023-01-09)","type":"extras"},{"doc":"Bug Fixes: Fixes Solicit.Plugs.Validation.QueryParams handling of nested maps ( #71 )","ref":"changelog.html#1-2-2-2022-03-24","title":"Change Log - 1.2.2 (2022-03-24)","type":"extras"},{"doc":"Bug Fixes: handle format validation errors from a changeset to remove &quot;unknown_error&quot; responses","ref":"changelog.html#1-2-1-2022-02-22","title":"Change Log - 1.2.1 (2022-02-22)","type":"extras"},{"doc":"Features: add 502 and 503 responses (#48)","ref":"changelog.html#1-2-0-2021-10-19","title":"Change Log - 1.2.0 (2021-10-19)","type":"extras"},{"doc":"Bug Fixes: error when negative page and negative limit provided (#46)","ref":"changelog.html#1-1-1-2021-09-14","title":"Change Log - 1.1.1 (2021-09-14)","type":"extras"},{"doc":"Features: rewrite CastPathParam plug as ValidatePathParam (#42) add default description to conflict (#40) add default description to conflict use git_ops to help automate releases add UUID helpers Fixes: format DateTimes as ISO-8601 strings in JSON (#45)","ref":"changelog.html#1-1-0-2021-09-07","title":"Change Log - 1.1.0 (2021-09-07)","type":"extras"},{"doc":"Features: Add accepted/1 Function to Response Package ResponseError functions allow overriding default description","ref":"changelog.html#1-0-12-2021-06-11","title":"Change Log - 1.0.12 (2021-06-11)","type":"extras"}]